-------------------------------------------------------
--! @file
--! @brief 2:1 Mux using with-select (セレクト付き2:1マルチプレクサ)
-------------------------------------------------------

--! Use standard library (標準ライブラリを使用)
library ieee;
--! Use logic elements
    use ieee.std_logic_1164.all;

--! Mux entity brief description (マルチプレクサの概要)

--! Detailed description of this 
--! mux design element.
--! (このマルチプレクサの
--! 詳細を記載)
entity mux_using_with_jpn is
    port (
        din_0   : in  std_logic; --! Mux first input (1番目の入力)
        din_1   : in  std_logic; --! Mux Second input (2番目の入力)
        sel     : in  std_logic; --! Select input (選択信号入力)
        mux_out : out std_logic  --! Mux output (マルチプレクサの出力)
    );
end entity;

--! @brief Architecture definition of the MUX
--! @details More details about this mux element.
architecture behavior of mux_using_with_jpn is
begin
    with (sel) select
    mux_out <= din_0 when '0',
               din_1 when others;
end architecture;

